package org.docx4j.openpackaging.parts.opendope;

import javax.xml.bind.JAXBContext;
import org.apache.commons.logging.Log;
import org.docx4j.openpackaging.exceptions.InvalidFormatException;
import org.docx4j.openpackaging.parts.PartName;
import org.opendope.questions.Question;
import com.openexchange.log.LogFactory;

public class QuestionsPart extends JaxbCustomXmlDataStoragePart<org.opendope.questions.Questionnaire> {

	private static Log log = LogFactory.getLog(QuestionsPart.class);

	public QuestionsPart(PartName partName) throws InvalidFormatException {
		super(partName);
		init();
	}

	public QuestionsPart(PartName partName, JAXBContext jc) throws InvalidFormatException {
		super(partName, jc);
		init();
	}

	public static Question getQuestionById(
			org.opendope.questions.Questionnaire questionnaire,
			String id) {

		for (Question qu : questionnaire.getQuestions().getQuestion() ) {

			if (qu.getId().equals(id))
				return qu;
		}

		log.warn("Question " + id + " is missing");
		return null;
	}

}
