/*
 *  Copyright 2010, Plutext Pty Ltd.
 *   
 *  This file is part of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License"); 
    you may not use this file except in compliance with the License. 

    You may obtain a copy of the License at 

        http://www.apache.org/licenses/LICENSE-2.0 

    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, 
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
    See the License for the specific language governing permissions and 
    limitations under the License.

 */


package org.xlsx4j.sml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for CT_MapInfo complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="CT_MapInfo">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="Schema" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}CT_Schema" maxOccurs="unbounded"/>
 *         &lt;element name="Map" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}CT_Map" maxOccurs="unbounded"/>
 *       &lt;/sequence>
 *       &lt;attribute name="SelectionNamespaces" use="required" type="{http://www.w3.org/2001/XMLSchema}string" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_MapInfo", propOrder = {
    "schema",
    "map"
})
public class CTMapInfo {

    @XmlElement(name = "Schema", required = true)
    protected List<CTSchema> schema;
    @XmlElement(name = "Map", required = true)
    protected List<CTMap> map;
    @XmlAttribute(name = "SelectionNamespaces", required = true)
    protected String selectionNamespaces;

    /**
     * Gets the value of the schema property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the schema property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSchema().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CTSchema }
     * 
     * 
     */
    public List<CTSchema> getSchema() {
        if (schema == null) {
            schema = new ArrayList<CTSchema>();
        }
        return this.schema;
    }

    /**
     * Gets the value of the map property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the map property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getMap().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CTMap }
     * 
     * 
     */
    public List<CTMap> getMap() {
        if (map == null) {
            map = new ArrayList<CTMap>();
        }
        return this.map;
    }

    /**
     * Gets the value of the selectionNamespaces property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getSelectionNamespaces() {
        return selectionNamespaces;
    }

    /**
     * Sets the value of the selectionNamespaces property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setSelectionNamespaces(String value) {
        this.selectionNamespaces = value;
    }

}
